{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}
{$N+,S+,X+,R+}
Uses App,Objects,Menus,Drivers,Views,Stddlg,Dos,Memory,Dialogs,Msgbox;
{----------------------------------------------------------}
Const
  cmCan=205;
  cmDelete=206;
  cmSearch=207;
  cmEdit=208;
  cmAdd=209;

  cmAddTBF=210;
  cmEditTBF=211;
  cmSearchTBF=212;
  cmDeleteTBF=213;
  cmTrans=214;
  cmBaseInfo=215;

  WinCom1 : TCommandSet = [cmSave, cmAddTBF, cmSaveAs,
  cmEditTBF, cmSearchTBF, cmDeleteTBF,cmBaseInfo];
  WinCom2 : TCommandSet = [cmOpen];
  {----------------------------------------------------------}
Type
  PData = ^TData;
  TData = Object(TObject)
    Name_ : PString; {⨯ ࠭}
    H21E_ : PString; {樥 । ⮪}
    Pk_   : Word;    {魮 }
    Ikmax_: Word;    {ᨬ ⮪ }
    Kbo_  : Real;
    Fg_   : Real;    {࠭筠 }
    Ukb_  : Real;    {殮 -}
    Constructor Init(_Name, _H21E : String;
      _Pk, _Ikmax : Word; _Kbo, _Fg, _Ukb : Real);
    Destructor Done;Virtual;
  End;
  {----------------------------------------------------------}
Type
  PInterior = ^TInterior;
  TInterior = Object(TScroller)
    MyConst : String;
    Constructor Init(Var Bounds:TRect;Hs,Vs:PScrollBar);
    Procedure Draw;Virtual;
    Function ReadFile:Boolean;
    Destructor Done;Virtual;
    Procedure HandleEvent(Var Event:TEvent);Virtual;
    Procedure MyCloseFile;
    Procedure DeleteItem;
    Procedure AddItem(Edit:Boolean);
    Procedure SearchItem;
    Procedure BaseInfo;
  End;
  {----------------------------------------------------------}
Type
  PWorkWin = ^TWorkWin;
  TWorkWin = Object(TWindow)
    Constructor Init(Bounds:TRect);
  End;
  {----------------------------------------------------------}

Var
  Rf:Boolean;
  Pw:PWorkWin;
  Ps:PCollection;
  Location:Word;
  Interior:PInterior;

  {----------------------------------------------------------}
Type
  TMyTBF = Object(TApplication)
    Constructor Init;
    Procedure InitStatusLine;Virtual;
    Procedure InitMenuBar;Virtual;
    Procedure HandleEvent(Var Event:TEvent);Virtual;
    Procedure FileOpen;
    Procedure FileSave;
    Procedure FileSaveAs;
    Procedure ChangeDir;
    Procedure Dialog;
    Destructor Done;Virtual;
  End;
  {----------------------------------------------------------}

Type
  DataType = Record
    Name  : String[7];{⨯}
    Pk,Ik_Max: Integer;
    Kbo,Fg,Ukb: Real;
    H21E  : String[10];
  End;
  {----------------------------------------------------------}

  HeadFile = Record
    Ind:Array[1..4] Of Char;
    Copyright:String[50];
    CopyrightEnd:Array [1..3] Of Char;
    VerFileBase:Single;
    InfoBase:String[100];
    Pole1,
    Pole2,
    Pole3,
    Pole4,
    Pole5,
    Pole6,
    Pole7:String[11];
  End;
{----------------------------------------------------------}
Const
  HeadTBF : HeadFile = (Ind : 'MG'#8#8;
    Copyright : #8'This is Copyright (c) MarinovSoft 2002.' ;
    CopyrightEnd : #10#13#26;
    VerFileBase : 2.0;
    InfoBase : ' MarinovSoft.';
    Pole1 : '';
    Pole2 : 'h21';
    Pole3 : 'I, ';
    Pole4 : 'I max, ';
    Pole5 : 'P max, ';
    Pole6 : 'Fh21, ';
    Pole7 : 'U, ');

  {----------------------------------------------------------}

Var
  TBFFile : File;
  Opfilef:Boolean;
  Heads:HeadFile;
  Data:DataType;
  Editing:Boolean;
  Mytbf:TMyTBF;

  {----------------------------------------------------------}

Constructor TWorkWin.Init(Bounds:TRect);
Var
  Hs,Vs:PScrollBar;
Begin
  TWindow.Init(Bounds,'',0);
  GetClipRect(Bounds);
  Bounds.Grow(-1,-1);
  Vs:=StandardScrollBar(sbVertical+sbHandleKeyboard);
  Hs:=StandardScrollBar(sbHorizontal+sbHandleKeyboard);
  Interior:=New(PInterior,Init(Bounds,Hs,Vs));
  Insert(Interior)
End;
{----------------------------------------------------------}

Constructor TData.Init;
Begin
  While Length(_Name) < 10 Do _Name:=_Name+' ';
  Name_:=NewStr(_Name);
  While Length(_H21E) < 7 Do _H21E:=_H21E+' ';
  H21E_:=NewStr(_H21E);
  Pk_:=_Pk;
  Ikmax_:=_Ikmax;
  Kbo_:=_Kbo;
  Fg_:=_Fg;
  Ukb_:=_Ukb;
End;
{----------------------------------------------------------}

Destructor TData.Done;
Begin
  DisposeStr(H21E_);
  DisposeStr(Name_);
End;
{----------------------------------------------------------}

Procedure TMyTBF.InitStatusLine;
Var R:TRect;
Begin
  GetExtent(R); { ६ R  न ᥣ ࠭}
  R.A.Y:=Pred(R.B.Y);{ ६ R  न ப }
  StatusLine:=New(PStatusLine,Init(R,NewStatusDef(0,$Ffff,
    NewStatusKey('~Alt-X~ 室',kbAltX,cmQuit,
    NewStatusKey('~F10~ ',kbF10,cmMenu,
    NewStatusKey('~F2~ ࠭',kbF2,cmSave,
    NewStatusKey('~F3~ ',kbF3,cmOpen,
    Nil)))),Nil)));
  DisableCommands(WinCom1);
End;
{----------------------------------------------------------}

Procedure TMyTBF.InitMenuBar;
Var R:TRect;
Begin
  GetExtent(R);
  R.B.Y:=Succ(R.A.Y);
  MenuBar:=New(PMenuBar,Init(R,NewMenu(
    NewSubMenu('',hcNoContext,
    NewMenu(
    NewItem('','F3',kbF3,cmOpen,hcNoContext,
    NewItem('࠭','F2',kbF2,cmSave,hcNoContext,
    NewItem('࠭ ...','',0,cmSaveAs,hcNoContext,
    NewItem('ଠ  ','',0,cmBaseInfo,hcNoContext,
    NewLine(
    NewItem(' ','',0,cmChangeDir,hcNoContext,
    NewItem('६ 室','',0,cmDosShell,hcNoContext,
    NewItem(' ࠡ','Alt-X',kbAltX,cmQuit,hcNoContext,
    Nil))))))))),
    NewSubMenu('ࠢ',hcNoContext,
    NewMenu(
     NewItem('','Insert',0,cmAddTBF,hcNoContext,
     NewItem('஢','F4',0,cmEditTBF,hcNoContext,
     NewItem('','Del',0,cmDeleteTBF,hcNoContext,
     Nil)))),
     NewSubMenu('',hcNoContext,
     NewMenu(
     NewItem('...','F7',kbF7,cmSearchTBF,hcNoContext,
     Nil)),
     NewSubMenu('',hcNoContext,
     NewMenu(
     NewItem('⥫','Shift+F1',kbShiftF1,cmTrans,hcNoContext,
     NewItem('ᯮ짮 ','',0,cmTrans,hcNoContext,
     NewLine(
     NewItem(' ணࠬ...','',0,cmTrans,hcNoContext,
     Nil))))),
     Nil)))))));
End;
{----------------------------------------------------------}

Function TInterior.ReadFile:Boolean;
Label Error;
Begin
  ReadFile:=False;
  Ps:=New(PCollection,Init(50,10));
  Reset(TBFFile,1);
  If FileSize(TBFFile) < 247 Then Goto Error;
  If ((FileSize(TBFFile)-247) Div SizeOf(DataType)) <>
     ((FileSize(TBFFile)-247)/SizeOf(DataType)) Then Goto Error;
  BlockRead(TBFFile,Heads,SizeOf(HeadTBF));
  If (Heads.Ind <> HeadTBF.Ind) Or
     (Heads.VerFileBase <> HeadTBF.VerFileBase)
  Then
  Begin
    Error:
    Close(TBFFile);
    MessageBox('ᮮ⢥⢨ ᨨ 䠩',Nil,mfError+mfOKButton);
    Exit;
  End;
  With Heads Do
  Begin
    While Length(Pole1) < 9 Do Pole1:=Pole1+' ';
    While Length(Pole2) < 6 Do Pole2:=Pole2+' ';
    While Length(Pole3) < 11 Do Pole3:=Pole3+' ';
    While Length(Pole4) < 11 Do Pole4:=Pole4+' ';
    While Length(Pole5) < 11 Do Pole5:=Pole5+' ';
    While Length(Pole6) < 11 Do Pole6:=Pole6+'  ';
    MyConst:= ' '+Pole1+Pole2+Pole3+' '+
    Pole4+' '+Pole5+'  '+Pole6+Pole7;
  End;
  While Not (EoF(TBFFile) Or LowMemory) Do
  Begin
    BlockRead(TBFFile,Data,SizeOf(Data));
    With Data Do
      With Ps^ Do
        Insert(New(PData, Init(Name, H21E, Pk,
          Ik_Max, Kbo, Fg, Ukb)));
  End;
  Location:=0;
  Editing:=False;
  Close(TBFFile);
  ReadFile:=True;
End;
{----------------------------------------------------------}

Procedure TInterior.Draw;
Var
  N,K:Integer;
  B:TDrawBuffer;
  Color:Byte;
  S1,S2:String;
  Dat:PData;
Begin
  Color:=GetColor(1);
  MoveChar(B,' ',Color,Size.X);
  MoveStr(B,
    Copy(MyConst,Delta.X,Size.X),Color);
  WriteLine(0,0,Size.X,1,B);
  If Delta.Y > Location Then
    Location:=Delta.Y;
  If Location > Delta.Y+Pred(Size.Y)-1 Then
    Location:=Delta.Y+Pred(Size.Y)-1;
  For N:=0 To Pred(Size.Y) Do
  Begin
    K:=Delta.Y+N;
    If K = Location Then
      Color:=GetColor(2)
    Else
      Color:=$17;
    MoveChar(B,' ',Color,Size.X);
    If K < Pred(Ps^.Count)+1 Then
    Begin
      Dat:=Ps^.At(K);
      With Dat^ Do
      Begin
        S2:='';
        S2:=Name_^;
        S2:=S2+H21E_^;
        S1:='';
        Str(Kbo_:9:3,S1);
        S2:=S2+S1;S1:='';
        Str(Ikmax_:12,S1);
        S2:=S2+S1;S1:='';
        Str(Pk_:12,S1);
        S2:=S2+S1;S1:='';
        Str(Fg_:11:2,S1);
        S2:=S2+S1;S1:='';
        Str(Ukb_:8:2,S1);
        S2:=S2+S1;
      End;
      MoveStr(B,Copy(S2,Delta.X+1,Size.X),Color);
    End;
    WriteLine(0,N+1,Size.X,1,B);
  End;
End;
{----------------------------------------------------------}

Constructor TInterior.Init(Var Bounds:TRect;Hs,Vs:PScrollBar);
Begin
  Inherited Init(Bounds,Hs,Vs);
  Rf:=ReadFile;
  GrowMode:=gfGrowHiX+gfGrowHiY;
  SetLimit(76,Ps^.Count);
End;
{----------------------------------------------------------}

Destructor TInterior.Done;
Begin
  Dispose(Ps,Done);
  Inherited Done;
End;
{----------------------------------------------------------}

Procedure TInterior.DeleteItem;
Begin
  With Ps^ Do Ps^.AtFree(IndexOf(At(Location)));
  Draw;
End;
{----------------------------------------------------------}

Procedure TInterior.AddItem(Edit:Boolean);
Var
  S:String;
  Control:Word;
  Localdata : Record
    _Name_ : String[7];
    _H21E_ : String[10];
    _Kbo_  : String[10];
    _Ikmax_: String[10];
    _Pk_   : String[10];
    _Fg_   : String[10];
    _Ukb_  : String[10];
  End;
  R:TRect;
  InWin:Pdialog;
  B1,B2,B3,B4,B5,B6,B7:PInputLine;
  Dat:PData;
  Code:Integer;
Begin
  Repeat
    If Edit Then
      S:='஢'
    Else
    Begin
      Str(Ps^.Count+1,S);
      S:='   '+S;
    End;
    FillChar(Localdata,SizeOf(Localdata),' ');
    R.Assign(15,5,48,18);
    InWin:=New(Pdialog,Init(R,S));
    With InWin^,Heads Do
    Begin
      R.Assign(2,2,14,3);
      B1:=New(PInputLine,Init(R,7));
      Insert(B1);
      R.Assign(2,1,15,2);
      Insert(New(PLabel,Init(R,Pole1,B1)));
      R.Assign(2,4,14,5);
      B2:=New(PInputLine,Init(R,10));
      Insert(B2);
      R.Assign(2,3,15,4);
      Insert(New(PLabel,Init(R,Pole2,B2)));
      R.Assign(2,6,14,7);
      B3:=New(PInputLine,Init(R,10));
      Insert(B3);
      R.Assign(2,5,15,6);
      Insert(New(PLabel,Init(R,Pole3,B3)));
      R.Assign(19,2,31,3);
      B4:=New(PInputLine,Init(R,10));
      Insert(B4);
      R.Assign(19,1,32,2);
      Insert(New(PLabel,Init(R,Pole4,B4)));
      R.Assign(19,4,31,5);
      B5:=New(PInputLine,Init(R,10));
      Insert(B5);
      R.Assign(19,3,32,4);
      Insert(New(PLabel,Init(R,Pole5,B5)));
      R.Assign(19,6,31,7);
      B6:=New(PInputLine,Init(R,10));
      Insert(B6);
      R.Assign(19,5,32,6);
      Insert(New(PLabel,Init(R,Pole6,B6)));
      R.Assign(19,8,31,9);
      B7:=New(PInputLine,Init(R,10));
      Insert(B7);
      R.Assign(19,7,32,8);
      Insert(New(PLabel,Init(R,Pole7,B7)));
      R.Assign(2,10,12,12);
      Insert(New(PButton,Init(R,'',cmOk,bfDefault)));
      R.Assign(20,10,31,12);
      Insert(New(PButton,Init(R,'室',cmCancel,bfNormal)));
      SelectNext(False);
    End;
    If Edit Then With Localdata Do
    Begin
      Dat:=Ps^.At(Location);
      _Name_:=Dat^.Name_^;
      _H21E_:=Dat^.H21E_^;
      Str(Dat^.Kbo_:10:3,_Kbo_);
      Str(Dat^.Ikmax_:10,_Ikmax_);
      Str(Dat^.Pk_:10,_Pk_);
      Str(Dat^.Fg_:10:2,_Fg_);
      Str(Dat^.Ukb_:10:2,_Ukb_);
      InWin^.SetData(Localdata);
    End;
    Control:=Desktop^.ExecView(InWin);
    If Control=cmOk Then With Data Do
    Begin
      If Edit Then DeleteItem;
      Name:=B1^.Data^;
      H21E:=B2^.Data^;
      Val(B3^.Data^,Kbo,Code);
      Val(B4^.Data^,Ik_Max,Code);
      Val(B5^.Data^,Pk,Code);
      Val(B6^.Data^,Fg,Code);
      Val(B7^.Data^,Ukb,Code);
      Ps^.Insert(New(PData, Init(Name, H21E,
        Pk, Ik_Max, Kbo, Fg, Ukb)));
      Editing:=True;
    End;
     Until Edit Or (Control=cmCancel);
     Draw;
End;
{----------------------------------------------------------}

Procedure TInterior.SearchItem;
Function Upstring(S:String):String;
Var
  K:Word;
Begin
  For K:=1 To Length(S) Do S[K]:=UpCase(S[K]);
  Upstring:=S;
End;
Var
  InWin:Pdialog;
  R:TRect;
  Stroka:String;
  P:PInputLine;
  K:Word;
  Dat:PData;
Begin
  R.Assign(15,8,45,16);
  InWin:=New(Pdialog,Init(R,':'));
  With InWin^ Do
  Begin
    R.Assign(11,3,20,4);
    P:=New(PInputLine,Init(R,7));
    Insert(P);
    R.Assign(1,1,29,2);
    Insert(New(PLabel,Init(R,' ࠧ  ᪠',P)));
    R.Assign(2,5,12,7);
    Insert(New(PButton,Init(R,'OK',cmOk,bfDefault)));
    R.Assign(18,5,28,7);
    Insert(New(PButton,Init(R,'⬥',cmCancel,bfNormal)));
    SelectNext(False)
  End;
  If Desktop^.ExecView(InWin) = cmCancel Then Exit;
  Stroka:=P^.Data^;
  While Length(Stroka) < 10 Do Stroka := Stroka+' ';
  Location:=0;
  Dat:=Ps^.At(Location);
  While (Upstring(Stroka) <> Upstring(String(Dat^.Name_^)))
        And (Location < Pred(Ps^.Count)) Do
  Begin
    Inc(Location);
    Dat:=Ps^.At(Location);
  End;
  If (Upstring(Stroka) <> Upstring(Dat^.Name_^)) Then
  Begin
    Location:=0;
    While (Upstring(Stroka) >= Upstring(Dat^.Name_^))
          And (Location < Pred(Ps^.Count)) Do
    Begin
      Inc(Location);
      Dat:=Ps^.At(Location);
    End;
  End;
  ScrollTo(Delta.X,Location);Draw;
End;
{----------------------------------------------------------}

Procedure TInterior.BaseInfo;
Var
  InWin:Pdialog;
  R:TRect;
  BBaseInfo:PInputLine;
  Pol1, Pol2, Pol3, Pol4, Pol5, Pol6, Pol7:PInputLine;
  Control:Word;
  LocalHeadTBF : Record
    BaseInfo:String[100];
    Pl1,
    Pl2,
    Pl3,
    Pl4,
    Pl5,
    Pl6,
    Pl7:String[11];
  End;

Begin
  R.Assign(10,5,70,19);
  InWin:= New(Pdialog,Init(R,'ଠ  '));
  With InWin^ Do
  Begin
    R.Assign(2,2,58,3);
    BBaseInfo:=New(PInputLine,Init(R,100));
    Insert(BBaseInfo);
    R.Assign(2,1,16,2);
    Insert(New(PLabel,Init(R,' ',BBaseInfo)));
    R.Assign(2,4,15,5);
    Pol1:=New(PInputLine,Init(R,11));
    Insert(Pol1);
    R.Assign(2,3,13,4);
    Insert(New(PLabel,Init(R,' 1',Pol1)));
    R.Assign(2,6,15,7);
    Pol2:=New(PInputLine,Init(R,11));
    Insert(Pol2);
    R.Assign(2,5,13,6);
    Insert(New(PLabel,Init(R,' 2',Pol2)));
    R.Assign(2,8,15,9);
    Pol3:=New(PInputLine,Init(R,11));
    Insert(Pol3);
    R.Assign(2,7,13,8);
    Insert(New(PLabel,Init(R,' 3',Pol3)));
    R.Assign(2,10,15,11);
    Pol4:=New(PInputLine,Init(R,11));
    Insert(Pol4);
    R.Assign(2,9,13,10);
    Insert(New(PLabel,Init(R,' 4',Pol4)));
    R.Assign(19,4,32,5);
    Pol5:=New(PInputLine,Init(R,11));
    Insert(Pol5);
    R.Assign(19,3,30,4);
    Insert(New(PLabel,Init(R,' 5',Pol5)));
    R.Assign(19,6,32,7);
    Pol6:=New(PInputLine,Init(R,11));
    Insert(Pol6);
    R.Assign(19,5,30,6);
    Insert(New(PLabel,Init(R,' 6',Pol6)));
    R.Assign(19,8,32,9);
    Pol7:=New(PInputLine,Init(R,11));
    Insert(Pol7);
    R.Assign(19,7,30,8);
    Insert(New(PLabel,Init(R,' 7',Pol7)));
    R.Assign(14,11,24,13);
    Insert(New(PButton,Init(R,'O~K~',cmOk,bfNormal)));
    R.Assign(34,11,44,13);
    Insert(New(PButton,Init(R,'~O~⬥',cmCancel,bfDefault)));
    SelectNext(False);
  End;
  With Heads, LocalHeadTBF Do
  Begin
    BaseInfo:=InfoBase;
    Pl1:=Pole1;
    Pl2:=Pole2;
    Pl3:=Pole3;
    Pl4:=Pole4;
    Pl5:=Pole5;
    Pl6:=Pole6;
    Pl7:=Pole7;
  End;
  InWin^.SetData(LocalHeadTBF);
  Control:=Desktop^.ExecView(InWin);

  If Control = cmOk Then
    With Heads, LocalHeadTBF Do
    Begin
      BaseInfo:=BBaseInfo^.Data^;
      Pl1:=Pol1^.Data^;
      Pl2:=Pol2^.Data^;
      Pl3:=Pol3^.Data^;
      Pl4:=Pol4^.Data^;
      Pl5:=Pol5^.Data^;
      Pl6:=Pol6^.Data^;
      Pl7:=Pol7^.Data^;
      InfoBase:=BaseInfo;
      Pole1:=Pl1;
      Pole2:=Pl2;
      Pole3:=Pl3;
      Pole4:=Pl4;
      Pole5:=Pl5;
      Pole6:=Pl6;
      Pole7:=Pl7;
      Editing:=True;
    End;
End;
{----------------------------------------------------------}

Procedure TInterior.MyCloseFile;
Const
  Msg:Word=0;
Begin
  If Editing Then
    Msg := MessageBox(#3'  . ࠭?',
      Nil,mfInformation+mfYesNoCancel);
  If Editing And (Msg=cmYes) Then Mytbf.FileSave;
  If Not Editing Or (Msg=cmYes) Or (Msg=cmNo) Then
  Begin
    DisableCommands(WinCom1);
    EnableCommands(WinCom2);
    Assign(TBFFile,'');
    Opfilef:=False;
    Done;
    Dispose(Pw,Done);
  End;
End;
{----------------------------------------------------------}

{----------------------------------------------------------}

Procedure TInterior.HandleEvent(Var Event:TEvent);
Var
  R:TPoint;
Begin
  Inherited HandleEvent(Event);
  Case Event.What Of
    evCommand:
    Case Event.Command Of
      cmClose:Begin MyCloseFile;ClearEvent(Event);End;
    End;
    evMouseDown:
    Begin
      MakeLocal(MouseWhere,R);
      Location:= Delta.Y+R.Y;
      If Location-1>=0 Then Dec(Location);
      Draw
    End;
    evKeyDown:
    Case Event.Keycode Of
      kbGrayMinus:If Location > Delta.Y Then
      Begin
        Dec(Location);
        Draw
      End;
      kbGrayPlus:If Location < Delta.Y+Pred(Size.Y) Then
      Begin
        Inc(Location);
        Draw
      End;
      kbDel: DeleteItem;{  㣮 , 祬 ᠭ  }
      kbIns: AddItem(False);{ }
      kbF4:  AddItem(True);{।஢ }
    End
  End;
End;
{----------------------------------------------------------}

Procedure TMyTBF.FileOpen;
Var
  Pf:PFileDialog;
  Control:Word;
  S:PathStr;
Begin
  New(Pf,Init('*.ttb','롥 㦭 䠩',' 䠩',fdOpenButton,0));
  Control:=Desktop^.ExecView(Pf);
  Case Control Of
    Stddlg.cmFileOpen, cmOk:
    Begin
      Pf^.GetFileName(S);
      Assign(TBFFile,S);
      {$i-}
      Reset(TBFFile);
      If IOResult<>0 Then
      Begin
        MessageBox(#3'  ⠪   .'+
          ' 㤥 ᮧ 䠩   '+S,Nil,mfWarning+mfOKButton);
        ReWrite(TBFFile,1);
        BlockWrite(TBFFile,HeadTBF,SizeOf(HeadTBF));
      End;
      Opfilef:=IOResult=0;
      {$I+}
      If Opfilef Then
      Begin
        DisableCommands(WinCom2);
        EnableCommands(WinCom1);
        Dialog;
      End;
    End;
  End;
  Dispose(Pf,Done);
  End;
{----------------------------------------------------------}

Procedure TMyTBF.FileSave;
Var
  Dat:PData;
  K:Word;
Begin
  ReWrite(TBFFile,1);
  BlockWrite(TBFFile,Heads,SizeOf(HeadTBF));
  If Pred(Ps^.Count)>0 Then
    For K:=0 To Pred(Ps^.Count) Do
    Begin
      Dat:=Ps^.At(K);
      Data.Name:= Dat^.Name_^;
      Data.H21E:= Dat^.H21E_^;
      Data.Pk:= Dat^.Pk_;
      Data.Ik_Max:= Dat^.Ikmax_;
      Data.Kbo:= Dat^.Kbo_;
      Data.Fg:= Dat^.Fg_;
      Data.Ukb:=Dat^.Ukb_;
      BlockWrite(TBFFile,Data,SizeOf(Data));
    End;
  Editing:=False;
  Close(TBFFile);
End;
{----------------------------------------------------------}

Procedure TMyTBF.FileSaveAs;
Var
  Pf:PFileDialog;
  S:PathStr;
  Control:Word;
  Con:Word;
Label Local;
Begin
  Local : New(Pf,Init('*.ttb','࠭ 䠩 ',' 䠩',fdOkButton+fdHelpButton,0));
  Control:=Desktop^.ExecView(Pf);
  Case Control Of
    Stddlg.cmFileOpen, cmOk:
    Begin
      Pf^.GetFileName(S);
      Assign(TBFFile,S);
      {$i-}
      Reset(TBFFile);
      {$I+}
      If IOResult=0 Then
      Begin
        Con:=MessageBox(' '+S+' 㦥 .'+
          ' १? ',Nil,mfWarning+mfYesButton+mfNoButton);
        Case Con Of
          $C : FileSave;
          $D : Goto Local;
        End;
      End
      Else
        FileSave;
    End;
  End;
End;
{----------------------------------------------------------}

Procedure TMyTBF.ChangeDir;
Var
  Pd:PChDirDialog;
  Control:Word;
Begin
  New(Pd,Init(cdNormal,0));
  Control:=Desktop^.ExecView(Pd);
  ChDir(Pd^.DirInput^.Data^);
  Dispose(Pd,Done);
End;
{----------------------------------------------------------}

Procedure TMyTBF.HandleEvent(Var Event:TEvent);
Begin
  Inherited HandleEvent(Event);
  If Event.What = evCommand Then
    Case Event.Command Of
      cmOpen:FileOpen;
      cmSave:FileSave;
      cmSaveAs:FileSaveAs;
      cmChangeDir:ChangeDir;
      cmAddTBF:Begin
        Interior^.AddItem(False);
        Interior^.Draw;
      End;
      cmEditTBF:Begin
        Interior^.AddItem(True);
        Interior^.Draw;
      End;
      cmDeleteTBF:Begin
        Interior^.DeleteItem;
        Interior^.Draw;
      End;
      cmSearchTBF:Begin
        Interior^.SearchItem;
        Interior^.Draw;
      End;
      cmBaseInfo:Begin
        Interior^.BaseInfo;
        Interior^.Draw;
        End;
     Else
       Exit
       End;
     ClearEvent(Event)
End;
{----------------------------------------------------------}

Procedure TMyTBF.Dialog;
Var
  R:TRect;
Begin
  R.Assign(0,0,80,23);
  Pw:=New(PWorkWin,Init(R));
  If Rf <> False Then Desktop^.Insert(Pw)
  Else Interior^.MyCloseFile;
End;
{----------------------------------------------------------}

Constructor TMyTBF.Init;
Var
  Dirinfo:SearchRec;
Begin
  Inherited Init;
  If ParamCount > 0 Then
  Begin
    FindFirst(ParamStr(1),AnyFile,Dirinfo);
    If DosError=0 Then
    Begin
      Assign(TBFFile,ParamStr(1));
      DisableCommands(WinCom2);
      EnableCommands(WinCom1);
      Opfilef:=True;
      Dialog;
    End
    Else MessageBox(#3', 㪠   ப,   ',Nil,mfError+mfOKButton);
  End;
End;
{----------------------------------------------------------}

Destructor TMyTBF.Done;
Begin
  If Opfilef=True Then Interior^.MyCloseFile;
  Inherited Done;
End;
Begin
  Mytbf.Init;
  Mytbf.Run;
  Mytbf.Done
End.